﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;

namespace TestScanRtf
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            this.InitializeComponent();
        }

        private void BtnDoIt_Click(object sender, EventArgs e)
        {
            this.richTextBox2.Clear();

            this.richTextBox1.Rtf = Properties.Resources.TestExtrakt;

            // an das ende des Textes scrollen
            this.richTextBox1.SelectionStart = this.richTextBox1.TextLength;
            this.richTextBox1.ScrollToCaret();

            // aktuelle Position im RichText
            int position = 0;
            // letzte Zeilen zum Finden der Abbruchposition
            Stack<string> lastLines = new Stack<string>();
            foreach (string line in this.richTextBox1.Lines)
            {
                // die aktuelle Zeile
                string line2 = line.Trim();
                if (string.IsNullOrWhiteSpace(line2))
                {
                    // Leerzeilen überspringen
                    position++;
                    continue;
                }

                try
                {
                    int index = line2.IndexOfAny(new char[] { '\t', ' ' });
                    if (index > 0)
                    {
                        // das erste Stück Text der aktuellen Zeile abschneiden
                        line2 = line2.Substring(0, index);
                    }

                    // die RTF-Position in der aktuellen Zeile finden
                    // ##########################################
                    // hier knallt es mit
                    // "startIndex darf nicht länger als die Länge der Zeichenfolge sein"
                    // ##########################################
                    int pos2 = this.richTextBox1.Find(line2, position, RichTextBoxFinds.None);
                    // Position für die nächste Zeile vorbereiten
                    position = pos2 + line.Length;

                    // das ist das Ziel der Übung
                    Point pt = this.richTextBox1.GetPositionFromCharIndex(pos2);
                    lastLines.Push(line);
                }
                catch (Exception ex)
                {
                    this.richTextBox2.AppendText("ex.Message:\r");
                    this.richTextBox2.AppendText(ex.Message);
                    this.richTextBox2.AppendText("\r\r");
                    this.richTextBox2.AppendText($"Text-Länge: {this.richTextBox1.TextLength}, Letzte Position: {position}\r\r");
                    this.richTextBox2.AppendText($"Zeile: \t\"{line}\"\r");
                    this.richTextBox2.AppendText($"Suchtext:\t\"{line2}\"\r\r");
                    string[] array = lastLines.ToArray();
                    this.richTextBox2.AppendText("die letzten gelesenen Zeilen:\r");
                    for (int i = 0; i < 5; i++)
                    {
                        this.richTextBox2.AppendText($"{array[4 - i]}\r");
                    }
                    break;
                }
            }
        }

        private void RichTextBox1_MouseMove(object sender, MouseEventArgs e)
        {
            int pos = this.richTextBox1.GetCharIndexFromPosition(e.Location);
            this.label1.Text = $"Pos = {pos}";
        }
    }
}
